SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 21:05'!
catalogue
 	| catalogue |
	catalogue := Dictionary new.
	catalogue add: (Association key: 1 value: 1).
	catalogue add: (Association key: 2 value: 2).
	^ catalogue.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:16'!
clientbook
	^Clientbook create.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:25'!
clientbookNotEmpty
	^(Clientbook create)addClient: 1 withPassword: 2.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:50'!
clock
	^ (TimeStampMock new)return:1.
! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:11'!
creditCard
	^ Card newNumber: 1231231212 expirationMonth: 08 expirationYear: 2013 owner: 'Manolo'.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:16'!
test01NewCartShouldBeEmpty
	| newCart aCatalogue|
	aCatalogue := Array new.
	newCart := Cart withCatalogue: aCatalogue .
	self assert: newCart listProducts = Bag new.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:49'!
test02CartShouldListProductAfterAdded
	| newCart  bag|
	newCart := Cart withCatalogue: self catalogue .	
		
	newCart add: 1.
	bag := newCart listProducts.
	self assert: (bag includes: 1 ).
	self assert: (bag size = 1 ).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:28'!
test02bQuantityShouldIncreaseInOne
	| newCart firstQuantity |
	newCart := Cart withCatalogue: self catalogue.
	firstQuantity := newCart quantityOf: 1.
	newCart add: 1.
	self assert: ((firstQuantity + 1) = (newCart quantityOf: 1)).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 16:28'!
test03CannotAddProductNotInCatalogue
	| newCart |
	newCart := Cart withCatalogue: self catalogue.
	self should: [ newCart add:15 ] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Cart invalidElementError ). self assert: ((newCart listProducts) isEmpty ) ].! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 16:29'!
test04IfModifyListProductNotModifyCartProduct
	|bagToModify newCart |
	newCart := Cart withCatalogue: self catalogue .	
		
	newCart add: 1.
	bagToModify := newCart listProducts.
	bagToModify removeAll.
	self assert: ( newCart listProducts includes: 1 ).
	self assert: ( newCart listProducts size = 1 ).! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 21:06'!
test05EmptyCartCheckoutShouldMakeAnException
	|newCart newCashier aCreditCard aMerchantProcessor|
	newCart := Cart withCatalogue: self catalogue .	
	newCashier := Cashier newWithSalesbook: (Set new) today: (Date newDay: 01 month: 09  year: 2012) .
	aCreditCard := self creditCard .
	aMerchantProcessor := MerchantProcessorMock create.
	self should: [newCashier checkout: newCart card: aCreditCard with:aMerchantProcessor] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Cashier emptyCartError). self assert: (aMerchantProcessor connections  = 0).]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:02'!
test06ExpiredCardCheckoutShouldMakeAnException
	|newCart newCashier aCreditCard aMerchantProcessor|
	newCart := Cart withCatalogue: self catalogue .	
	newCart add: 1.
	newCashier := Cashier newWithSalesbook: (Set new) today: (Date newDay: 01 month: 09  year: 2014) .
	aCreditCard := self creditCard .
	aMerchantProcessor := MerchantProcessorMock create.
	self should: [newCashier checkout: newCart card: aCreditCard with: aMerchantProcessor] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Card expiredCardError). self assert: (aMerchantProcessor connections  = 0).  ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 19:16'!
test07CreditCardWithNoCreditShouldReturnAnError
	|newCart newCashier aCreditCard aMerchantProcessor|
	newCart := Cart withCatalogue: self catalogue .	
	newCart add: 1.
	newCashier := Cashier newWithSalesbook: (Set new) today: (Date newDay: 01 month: 09  year: 2010) .
	aCreditCard := self creditCard .
	aMerchantProcessor := MerchantProcessorMock create.
	aMerchantProcessor forMethod: 'debit' return: [Error signal: Cashier noCreditError].
	self should: [newCashier checkout: newCart card: aCreditCard with: aMerchantProcessor] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Cashier noCreditError). self assert: (aMerchantProcessor connections  = 1).].
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 13:38'!
test08CreditCardWithCreditShouldIncrementTheSalesbook
	|newCart newCashier aCreditCard aMerchantProcessor|
	newCart := Cart withCatalogue: self catalogue .	
	newCart add: 1.
	newCashier := Cashier newWithSalesbook: (Set new) today: (Date newDay: 01 month: 09  year: 2010) .
	aCreditCard := self creditCard .
	aMerchantProcessor := MerchantProcessorMock create.
	aMerchantProcessor forMethod: 'debit' return: [].
	newCashier checkout: newCart card: aCreditCard with: aMerchantProcessor.
	self assert: (newCashier salesbook size = 1)

	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 19:16'!
test09StolenCreditCardShouldReturnAnError
	|newCart newCashier aCreditCard aMerchantProcessor|
	newCart := Cart withCatalogue: self catalogue .	
	newCart add: 1.
	newCashier := Cashier newWithSalesbook: (Set new) today: (Date newDay: 01 month: 09  year: 2010) .
	aCreditCard := self creditCard .
	aMerchantProcessor := MerchantProcessorMock create.
	aMerchantProcessor forMethod: 'debit' return: [Error signal: Cashier stolenCardError].
	self should: [newCashier checkout: newCart card: aCreditCard with: aMerchantProcessor] raise: Error withExceptionDo: [ :anError | self assert: (anError messageText   = Cashier stolenCardError). self assert: (aMerchantProcessor connections  = 1).].
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:24'!
test10InvalidUserShouldReturnAnException
	| newInterface |
	newInterface := Interface withClientbook: self clientbook andCatalogue: self catalogue andClock: nil.
	self
		should: [ newInterface createFor: 'manolo' withPass: 'poo' ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Clientbook invalidClientError ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:50'!
test11validUserShouldReturnACartId
	| newInterface |
	newInterface := Interface withClientbook: self clientbookNotEmpty andCatalogue: self catalogue andClock: self clock.
	self assert: (newInterface listCart: (newInterface createFor: 1 withPass: 2)) isEmpty! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:24'!
test12invalidCartIdShouldReturnAnError
	| newInterface |
	newInterface := Interface withClientbook: self clientbookNotEmpty andCatalogue: self catalogue andClock: nil.
	self
		should: [ newInterface listCart: 16 ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Interface invalidCartIdError ]! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:50'!
test13differentsCartShouldHaveDifferentsId
	| newInterface cartId1 cartId2 |
	newInterface := Interface withClientbook: self clientbookNotEmpty andCatalogue: self catalogue andClock: self clock.
	cartId1 := newInterface createFor: 1 withPass: 2.
	cartId2 := newInterface createFor: 1 withPass: 2.
	self assert: cartId1 ~= cartId2! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:50'!
test14inExpiredTimeCartActionShouldReturnError
	| newInterface cartId1 clock|
	clock := self clock.
	newInterface := Interface withClientbook: self clientbookNotEmpty andCatalogue: self catalogue andClock: clock.

	cartId1 := newInterface createFor: 1 withPass: 2.
	clock return: 90.
	self
		should: [ newInterface listCart: cartId1 ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Interface expiredTimeError  ]! !

Object subclass: #Card
	instanceVariableNames: 'number monthExpiration yearExpiration owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Card class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:01'!
expiredCardError
	^'Tarjeta vencida'.! !

!Card class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:08'!
newNumber: aCardNumber expirationMonth: aMonth expirationYear: aYear owner: aName 
	^Card new number: aCardNumber expirationMonth: aMonth expirationYear: aYear owner: aName ! !

!Card methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:01'!
isExpiredOn: aDate
	^(yearExpiration < aDate year) |  (yearExpiration = aDate year and: [monthExpiration < aDate monthIndex]) ifTrue: [ Error signal: Card expiredCardError ]! !

!Card methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 19:08'!
monthExpiration
	^monthExpiration! !

!Card methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:09'!
number: aCardNumber expirationMonth: aMonth expirationYear: aYear owner: aName 
	number:=aCardNumber.
	monthExpiration := aMonth.
	yearExpiration := aYear.
	owner := aName.
	! !

!Card methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 19:08'!
yearExpiration
	^yearExpiration
! !

Object subclass: #Cart
	instanceVariableNames: 'bag catalogue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/27/2013 21:45'!
create
	^Cart new initialize.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:42'!
invalidElementError
	^'elemento invalido'.! !

!Cart class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:22'!
withCatalogue: aCatalogue
	|cart|
      cart  := Cart new.
	cart setCatalogue: aCatalogue.
	^ cart.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:42'!
add: aProduct
	(catalogue includes: aProduct ) ifFalse: [ Error signal: Cart invalidElementError ].
	bag add: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 16:23'!
catalogue
	^catalogue.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/27/2013 21:45'!
initialize
	bag := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 18:58'!
isEmpty
	^bag size = 0.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 19:24'!
listProducts
	^ Bag newFrom:  bag.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 19:24'!
quantityOf: aProduct
	^bag occurrencesOf: aProduct.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 5/29/2013 20:23'!
setCatalogue: aCatalogue
	catalogue := aCatalogue.! !

Object subclass: #Cashier
	instanceVariableNames: 'salesbook today'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:15'!
emptyCartError
	^'Carrito vacio'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:04'!
newWithSalesbook: aSalesBook today: aDate
	^Cashier new initializeWithSalesbook: aSalesBook today: aDate.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:50'!
noCreditError
	^'Tarjeta sin credito'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 19:36'!
stolenCardError
	^'Tarjeta robada'.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:02'!
checkCardExpiration: aCard
	^aCard isExpiredOn: today.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:25'!
checkEmptyCart: aCart
	 ( aCart isEmpty ) ifTrue: [ Error signal: (Cashier emptyCartError) ]! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 13:53'!
checkout: aCart card: aCard with: aMerchant
	|finalSum result newSale|
	
	self checkEmptyCart: aCart.
	self checkCardExpiration: aCard.
	finalSum:=0.
	aCart listProducts do: [ :each | finalSum := finalSum + aCart catalogue at: each ].
	result := aMerchant debit: finalSum from: aCard.
	newSale := Sale cart: aCart amount: finalSum card: aCard.
	salesbook add: newSale.
	^result.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:05'!
initializeWithSalesbook: aSalesbook today: aDate 
	salesbook := aSalesbook.
	today := aDate.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 13:39'!
salesbook
	^ salesbook! !

Object subclass: #Clientbook
	instanceVariableNames: 'clients'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Clientbook class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:16'!
create
	^Clientbook new initialize .! !

!Clientbook class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:14'!
invalidClientError
	^'Cliente invalido'.! !

!Clientbook methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:24'!
addClient:aClient withPassword: aPassword
	clients add:(Association key: aClient value: aPassword)
	! !

!Clientbook methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:42'!
existClient: aClient withPassword: aPassword	
		(clients includesKey: aClient) ifFalse: [ Error signal: Clientbook invalidClientError. ].
		((clients at:aClient) = aPassword) ifFalse: [ Error signal: Clientbook invalidClientError. ]! !

!Clientbook methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 20:16'!
initialize
	clients:=Dictionary new.! !

Object subclass: #Interface
	instanceVariableNames: 'carts clientBook catalogue clock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Interface class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:37'!
expiredTimeError
	^'Paso el tiempo'! !

!Interface class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:12'!
invalidCartIdError
	^'Id de carrito invalido'! !

!Interface class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:46'!
withClientbook: aClientbook andCatalogue: aCatalogue andClock: aClock
	^ Interface new withClientbook: aClientbook andCatalogue: aCatalogue andClock: aClock! !

!Interface methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:27'!
createFor: aClient withPass: aPassword 
 
   clientBook existClient: aClient withPassword: aPassword.
   carts add: (Association key: (Cart withCatalogue: catalogue) value: (clock time)).
   ^carts size.




! !

!Interface methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:48'!
listCart: aCartId
	(carts size < aCartId) ifTrue:[^ Error signal: (Interface invalidCartIdError) ].
	(clock time - (carts at: aCartId)value  > 30) ifTrue:[^ Error signal: (Interface expiredTimeError) ].
	^(carts at: aCartId) key listProducts .! !

!Interface methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:27'!
withClientbook: aClientbook andCatalogue: aCatalogue andClock: aClock.
	clientBook := aClientbook.
	carts := OrderedCollection new.
	catalogue := aCatalogue.
	clock :=  aClock.! !

Object subclass: #MerchantProcessorMock
	instanceVariableNames: 'valueToReturn connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!MerchantProcessorMock class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:52'!
create
	^MerchantProcessorMock new initialize.! !

!MerchantProcessorMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 21:05'!
connections
	^connections.! !

!MerchantProcessorMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 21:09'!
debit: anAmount from: aCard
	connections := connections + 1.
	^(valueToReturn at: 'debit') value. ! !

!MerchantProcessorMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 20:54'!
forMethod: aMethod return: aValue
	valueToReturn add: (Association key: aMethod value: aValue )! !

!MerchantProcessorMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/3/2013 21:05'!
initialize
	valueToReturn := Dictionary new.
	connections := 0.! !

Object subclass: #Sale
	instanceVariableNames: 'cart amount card'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Sale class methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 13:54'!
cart:aCart amount: anAmount card: aCard 
	^Sale new cart:aCart amount: anAmount card: aCard.! !

!Sale methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 13:54'!
cart:aCart amount: anAmount card: aCard 
	cart:=aCart.
	amount:=anAmount.
	card:= aCard.! !

Object subclass: #TimeStampMock
	instanceVariableNames: 'calls valueToReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TimeStampMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:35'!
return: aValue
	valueToReturn := aValue.
	! !

!TimeStampMock methodsFor: 'as yet unclassified' stamp: 'KevinKujawski 6/5/2013 21:35'!
time
	^valueToReturn.
	! !
